package info.textgrid.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the Basket service. Represents a row in the &quot;textgridrep_Basket&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link info.textgrid.model.impl.BasketModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link info.textgrid.model.impl.BasketImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see Basket
 * @see info.textgrid.model.impl.BasketImpl
 * @see info.textgrid.model.impl.BasketModelImpl
 * @generated
 */
public interface BasketModel extends BaseModel<Basket> {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this interface directly. All methods that expect a basket model instance should use the {@link Basket} interface instead.
     */

    /**
     * Returns the primary key of this basket.
     *
     * @return the primary key of this basket
     */
    public long getPrimaryKey();

    /**
     * Sets the primary key of this basket.
     *
     * @param primaryKey the primary key of this basket
     */
    public void setPrimaryKey(long primaryKey);

    /**
     * Returns the uuid of this basket.
     *
     * @return the uuid of this basket
     */
    @AutoEscape
    public String getUuid();

    /**
     * Sets the uuid of this basket.
     *
     * @param uuid the uuid of this basket
     */
    public void setUuid(String uuid);

    /**
     * Returns the basket ID of this basket.
     *
     * @return the basket ID of this basket
     */
    public long getBasketId();

    /**
     * Sets the basket ID of this basket.
     *
     * @param basketId the basket ID of this basket
     */
    public void setBasketId(long basketId);

    /**
     * Returns the user ID of this basket.
     *
     * @return the user ID of this basket
     */
    public long getUserId();

    /**
     * Sets the user ID of this basket.
     *
     * @param userId the user ID of this basket
     */
    public void setUserId(long userId);

    /**
     * Returns the user uuid of this basket.
     *
     * @return the user uuid of this basket
     * @throws SystemException if a system exception occurred
     */
    public String getUserUuid() throws SystemException;

    /**
     * Sets the user uuid of this basket.
     *
     * @param userUuid the user uuid of this basket
     */
    public void setUserUuid(String userUuid);

    /**
     * Returns the textgrid uri of this basket.
     *
     * @return the textgrid uri of this basket
     */
    @AutoEscape
    public String getTextgridUri();

    /**
     * Sets the textgrid uri of this basket.
     *
     * @param textgridUri the textgrid uri of this basket
     */
    public void setTextgridUri(String textgridUri);

    /**
     * Returns the order of this basket.
     *
     * @return the order of this basket
     */
    public int getOrder();

    /**
     * Sets the order of this basket.
     *
     * @param order the order of this basket
     */
    public void setOrder(int order);

    @Override
    public boolean isNew();

    @Override
    public void setNew(boolean n);

    @Override
    public boolean isCachedModel();

    @Override
    public void setCachedModel(boolean cachedModel);

    @Override
    public boolean isEscapedModel();

    @Override
    public Serializable getPrimaryKeyObj();

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj);

    @Override
    public ExpandoBridge getExpandoBridge();

    @Override
    public void setExpandoBridgeAttributes(BaseModel<?> baseModel);

    @Override
    public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext);

    @Override
    public Object clone();

    @Override
    public int compareTo(Basket basket);

    @Override
    public int hashCode();

    @Override
    public CacheModel<Basket> toCacheModel();

    @Override
    public Basket toEscapedModel();

    @Override
    public Basket toUnescapedModel();

    @Override
    public String toString();

    @Override
    public String toXmlString();
}
